
//Title:       8iPLSQL
//Version:
//Copyright:   Copyright (c) 2000
//Author:      Bulusu Lakshman
//Company:
//Description:

import java.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class empMaster {
  public static void hireEmp(int    i_empno,
                             String i_ename,
                             String i_job,
                             int    i_mgr,
                             String i_hiredate,
                             float  i_sal,
                             float  i_comm,
                             int    i_deptno,
                             String[] msg)
  throws SQLException {
    Connection conn = new OracleDriver().defaultConnection();
    String sql1 = "SELECT empno FROM emp WHERE empno = ?" ;
    String sql2 = "INSERT INTO emp VALUES (?,?,?,?,?,?,?,?)";
    int ret_code;
    try {
       PreparedStatement pstmt = conn.prepareStatement(sql1);
       pstmt.setInt(1, i_empno);
       ResultSet rset = pstmt.executeQuery();
       if (rset.next()) {
         msg[0] = "This employee already exists.";
         rset.close();
         pstmt.close();
         }
        else
         {
         pstmt = conn.prepareStatement(sql2);
         pstmt.setInt(1, i_empno);
         pstmt.setString(2, i_ename);
         pstmt.setString(3, i_job);
         pstmt.setInt(2, i_mgr);
         pstmt.setString(2, i_hiredate);
         pstmt.setFloat(2, i_sal);
         pstmt.setFloat(2, i_comm);
         pstmt.setInt(2, i_deptno);
         pstmt.executeUpdate();
         rset.close();
         pstmt.close(); }
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage());}
   }

  public static void fireEmp(int i_empno)
  throws SQLException {
    Connection conn = new OracleDriver().defaultConnection();
    String sql = "DELETE emp WHERE empno = ?";
    int ret_code;
    try {
         PreparedStatement pstmt = conn.prepareStatement(sql);
         pstmt.setInt(1, i_empno);
         pstmt.executeUpdate();
         pstmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage());}
   }

public static void transferEmp(int i_empno, int i_todept)
  throws SQLException {
    Connection conn = new OracleDriver().defaultConnection();
    String sql = "UPDATE emp SET deptno = ? WHERE empno = ?";
    int ret_code;
    try {
         PreparedStatement pstmt = conn.prepareStatement(sql);
         pstmt.setInt(1, i_todept);
         pstmt.setInt(2, i_empno);
         pstmt.executeUpdate();
         pstmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage());}
   }

public static void hikeEmpSal(int i_empno, int i_comm)
  throws SQLException {
    Connection conn = new OracleDriver().defaultConnection();
    String sql = "UPDATE emp SET sal = sal + (1.25*?) WHERE empno = ?";
    int ret_code;
    try {
         PreparedStatement pstmt = conn.prepareStatement(sql);
         pstmt.setInt(1, i_comm);
         pstmt.setInt(2, i_empno);
         pstmt.executeUpdate();
         pstmt.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage());}
   }
}

