import java.sql.*;
import oracle.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class BFILEExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
BufferedOutputStream outStream = null;
FileOutputStream fileStream = null;
int buffSize = 10;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    conn.setAutoCommit(false);

    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT bfile_data from lob_tab WHERE id = 1");

    if (rset.next()) {
      BFILE bfile_data = ((OracleResultSet)rset).getBFILE(1);
      
      if (bfile_data.fileExists()) {
        bfile_data.openFile();

      InputStream inStream = bfile_data.getBinaryStream();

      // Open the output file for writing
      fileStream = new FileOutputStream("bfile.dat");
      outStream = new BufferedOutputStream(fileStream, buffSize);      

      byte[] nextChunk = new byte[buffSize];
      
     //read the first chunk of data from the BFILE
       
     int numOfBytes = inStream.read(nextChunk, 0, buffSize);

    // write the chunk read into the output file read nextChunk from the BLOB in a loop
     while (numOfBytes != -1) {
       outStream.write(nextChunk, 0, buffSize);
       numOfBytes = inStream.read(nextChunk, 0, buffSize);
      }
      outStream.close();
      inStream.close();     
     } // if fileExists() 
    } // if rset.next()   
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.out.println(e.getMessage());}
   }
}
