import java.sql.*;
import oracle.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class BLOBExample {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
BufferedInputStream inStream = null;
FileInputStream fileStream = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    conn.setAutoCommit(false);

    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT blob_data from lob_tab WHERE id = 1 FOR UPDATE");

    if (rset.next()) {
      BLOB blob_data = ((OracleResultSet)rset).getBLOB(1);
      
      OutputStream outStream = blob_data.getBinaryOutputStream();
      //compute buffer size for writing to BLOB.
       int buffSize = blob_data.getBufferSize();
       fileStream = new FileInputStream("test.bmp");      
       inStream = new BufferedInputStream(fileStream, buffSize);
       
       byte[] nextChunk = new byte[buffSize];
       //read the first chunk of data from the file
       int numOfBytes = inStream.read(nextChunk,0, buffSize);

       //write the chunk read to the BLOB
       while (numOfBytes != -1) {
         outStream.write(nextChunk, 0, numOfBytes);
         numOfBytes = inStream.read(nextChunk, 0, buffSize);
       }
       outStream.close();
       inStream.close();
       conn.commit();
    }    
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.out.println(e.getMessage());}
   }
}
