import java.sql.*;
import oracle.sql.*;
import java.io.*;
import oracle.jdbc.driver.*;

public class CLOBExample1 {
  public static void main(String[] args)
  throws SQLException {
int ret_code;
Connection conn = null;
BufferedWriter bufWriter = null;
FileWriter fileWriter = null;
  try {
      //Load and register Oracle driver
       DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
  //Establish a connection

    conn = DriverManager.getConnection("jdbc:oracle:thin:@training:1521:Oracle", "oratest", "oratest");

    conn.setAutoCommit(false);

    Statement stmt = conn.createStatement();
    ResultSet rset = stmt.executeQuery("SELECT clob_data from lob_tab WHERE id = 1");

    if (rset.next()) {
      CLOB clob_data = ((OracleResultSet)rset).getCLOB(1);
      
      Reader inStream = clob_data.getCharacterStream();
      //compute buffer size for writing to CLOB.
       int buffSize = clob_data.getBufferSize();
       fileWriter = new FileWriter("out.dat");      
       bufWriter = new BufferedWriter(fileWriter, buffSize);
       
       char[] nextChunk = new char[buffSize];
       //read the first chunk of data from the CLOB
       int numOfBytes = inStream.read(nextChunk,0, buffSize);

       //write the chunk read to the File
       while (numOfBytes != -1) {
         bufWriter.write(nextChunk, 0, numOfBytes);
         numOfBytes = inStream.read(nextChunk, 0, buffSize);
       }
       inStream.close();
       bufWriter.close();
//       conn.commit();
    }    
    conn.close();
       } catch (SQLException e) {ret_code = e.getErrorCode(); System.err.println(ret_code + e.getMessage()); conn.close();}
         catch (Exception e) {System.out.println(e.getMessage());}
   }
}
