import java.io.*;

import javax.servlet.*;

import javax.servlet.http.*;

import java.util.* ;

//************************************************************

public class Department extends HttpServlet

{

//************************************************************

public void service ( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException {

response.setContentType("text/html");

PrintWriter out = response.getWriter() ;

 

String action = request.getParameter("action") ;

if ( (action == null)|| (action.equals("")) ) 

{

printInitialForm(request, out) ;

return ;

}

if (action.equals("ADD") ) addDepartment(request, out) ;

if (action.equals("MODIFY") ) modifyDepartment(request, out) ;

if (action.equals("DELETE") ) deleteDepartment(request, out) ;

}

//************************************************************

private void printInitialForm(HttpServletRequest request, PrintWriter out) throws ServletException, IOException

{

printHeader(out) ;

printForm(request, out) ; 

printFooter(out) ;

}


//************************************************************

private void addDepartment(HttpServletRequest request, PrintWriter out) throws ServletException, IOException

{

printHeader(out) ;

printForm(request, out) ; 

String mesg = new String("") ;

String deptNo = request.getParameter("deptNo") ;

String deptName = request.getParameter("deptName") ;

String deptLoc = request.getParameter("deptLoc") ;

if( (deptNo == null) || deptNo.equals("")||(deptName == null) ||

deptName.equals("")||(deptLoc == null)||deptLoc.equals("") ) 

{

mesg = "One or more of the input fields are blanks" ; 


}

else

{

int status = -1 ;

//Here is where you instantiate the bean and use it. 

//Here is an example of how the code can look
try {
 DeptBean myBean = new DeptBean() ;

 myBean.setdbDeptNo(Integer.parseInt(deptNo)) ;

 myBean.setdbDname(deptName) ;

 myBean.setdbLoc(deptLoc) ;

 status = myBean.InsertDept() ;
} catch (Exception e) { }

if(status == 0) mesg = "Department Successfully Added" ;

else mesg = "Failure to add Department" ;

}

 

//printHeader(out) ;

//printForm(request, out) ; 

printMessage(out, mesg) ;

printFooter(out) ;

}

//************************************************************

private void modifyDepartment(HttpServletRequest request, PrintWriter out) throws ServletException, IOException

{

String mesg = new String("") ;

String deptNo = request.getParameter("deptNo") ;

String deptName = request.getParameter("deptName") ;

String deptLoc = request.getParameter("deptLoc") ;

if( (deptNo == null) || deptNo.equals("")||(deptName == null) ||

deptName.equals("")||(deptLoc == null)||deptLoc.equals("") ) 

{

mesg = "One or more of the input fields are blanks" ; 

}

else

{

int status = -1 ;

//Here is where you instantiate the bean and use it. 

//Here is an example of how the code can look
try {

 DeptBean myBean = new DeptBean() ;

 myBean.setdbDeptNo(Integer.parseInt(deptNo)) ;

 myBean.setdbDname(deptName) ;

 myBean.setdbLoc(deptLoc) ;

 status = myBean.UpdateDept() ;

} catch (Exception e) { }

if(status == 0) mesg = "Department Successfully Modified" ;

else mesg = "Failure to modify Department" ;

}

 

printHeader(out) ;

printForm(request, out) ; 

printMessage(out, mesg) ;

printFooter(out) ;

}

//************************************************************

private void deleteDepartment(HttpServletRequest request, PrintWriter out) throws ServletException, IOException

{

String mesg = new String("") ;

String deptNo = request.getParameter("deptNo") ;

String deptName = request.getParameter("deptName") ;

String deptLoc = request.getParameter("deptLoc") ;

if( (deptNo == null) || deptNo.equals("")) 

{

mesg = "One or more of the input fields are blanks" ; 

}

else

{

int status = -1 ;

//Here is where you instantiate the bean and use it. 

//Here is an example of how the code can look

try {

 DeptBean myBean = new DeptBean() ;

 myBean.setdbDeptNo(Integer.parseInt(deptNo)) ;

 myBean.setdbDname(deptName) ;

 myBean.setdbLoc(deptLoc) ;

 status = myBean.DeleteDept() ;

} catch (Exception e) { }

if(status == 0) mesg = "Department Successfully Deleted" ;

else mesg = "Failure to delete Department" ;

}

 

printHeader(out) ;

printForm(request, out) ; 

printMessage(out, mesg) ;

printFooter(out) ;


}

//************************************************************

private void printHeader(PrintWriter out) 

{

out.println("<HTML>") ;

out.println("<HEAD>") ;

out.println("<TITLE> Department Maintenance Page </TITLE>") ;

out.println("</HEAD>") ;

out.println("<BODY>") ;

 

out.println("<H1> Department Maintenance Page </H1>") ;

out.println("<B>") ;

out.println("(Please enter department details and click on INSERT, UPDATE or DELETE. )") ;

out.println("</B>") ;

out.println("<BR>") ;

out.println("<BR>") ;

}

//void addDepartment(HttpServletRequest request, PrintWriter out) ;

//void modifyDepartment(HttpServletRequest request, PrintWriter out) ;

//void deleteDepartment(HttpServletRequest request, PrintWriter out) ;

 

//************************************************************

void printFooter(PrintWriter out)

{

out.println("</BODY>") ;

out.println("</HTML>") ;

}

//************************************************************

void printForm( HttpServletRequest request, PrintWriter out)

{

String deptNo = request.getParameter("deptNo") ;

if(deptNo == null) deptNo = "" ;

String deptName = request.getParameter("deptName") ;

if(deptName == null) deptName = "" ;

String deptLoc = request.getParameter("deptLoc") ;

if(deptLoc == null) deptLoc = "" ;

//out.println("<FORM METHOD=GET ACTION='/deptServlet'>") ;

out.println("<FORM METHOD=GET ACTION=Department>") ;

out.println("<TABLE>") ;

out.println("<TR>") ;

out.println("<TD> Department No: </TD>") ;

out.println("<TD> <INPUT TYPE=text NAME=deptNo VALUE='" + deptNo +"'>") ;

out.println("</TR>") ;

out.println("<TR>") ;

out.println("<TD> Department Name:</TD>") ;

out.println("<TD> <INPUT TYPE=text NAME=deptName VALUE='" + deptName + "'>") ;

out.println("</TR>") ;

out.println("<TR>") ;

out.println("<TD> Department Loc: </TD>") ;

out.println("<TD> <INPUT TYPE=text NAME=deptLoc VALUE='" + deptLoc + "'>") ;

out.println("</TR>") ;

out.println("</TABLE>") ;

out.println("<BR><BR>") ;

out.println("<INPUT TYPE=SUBMIT VALUE='ADD' NAME=action>") ;

out.println("<INPUT TYPE=SUBMIT VALUE='MODIFY' NAME=action>") ;

out.println("<INPUT TYPE=SUBMIT VALUE='DELETE' NAME=action>") ;

 

out.println("</FORM>") ;

}

//************************************************************

void printMessage(PrintWriter out, String mesg)

{

out.println("<BR>") ;

out.println("<B>") ;

out.println(mesg) ;

out.println("</B>") ; 

}

//************************************************************

} //END of CLASS

//************************************************************

//************************************************************

//************************************************************

 
