package DeptBeanManaged;

import java.io.Serializable;
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;

import javax.ejb.*;
import javax.naming.*;
import java.rmi.*;

public class DepartmentBean implements EntityBean {

  private EntityContext ctx;
  private int deptNo; // This is the primary Key
  private String deptName ;
  private String deptLoc ;

// Empty constructor for the container to create the bean instance 

public void DepartmentBean() { }

public void setEntityContext(EntityContext ctx) {
    System.out.println("setEntityContext called");
    this.ctx = ctx;
  }

public void unsetEntityContext() {
    System.out.println("unsetEntityContext called");
    this.ctx = null;
  }

public void ejbActivate() {
    System.out.println("ejbActivate called");
  }

public void ejbPassivate() {
    System.out.println("ejbPassivate called");
  }

  public void ejbLoad() throws RemoteException {

    Connection conn = null;
    PreparedStatement pstmt = null;
    ResultSet rset = null;
    deptNo =(int) Integer.parseInt((String) ctx.getPrimaryKey());
    try {
      conn = getConnection();
      pstmt  = conn.prepareStatement("select dname, loc from dept where deptNo = ?");
      pstmt.setInt(1, deptNo);
      rset = pstmt.executeQuery();
      if (rset.next()) {
        deptName = rset.getString(1);
        deptLoc = rset.getString(2) ;
      } else {
        String error = "ejbLoad: Department (" + deptNo + ") not found";
        System.out.println(error);
        throw new NoSuchEntityException (error);
       }
    } catch (SQLException e) {
      try {
      System.out.println("SQLException: " + e);
      throw new EJBException(e);
      } catch (EJBException ee) {System.out.println(ee);}
     
    } catch (NoSuchEntityException e) {System.out.println(e); }
      finally {
        try {
        if (rset != null) rset.close();
        if (pstmt != null) pstmt.close();
        } catch (SQLException e) {}
    }
  }

  public void ejbStore() throws RemoteException {

    Connection conn = null;
    PreparedStatement pstmt = null;

    try {
      conn = getConnection();
      pstmt = conn.prepareStatement("update dept set dname = ?, loc = ? where deptNo = ?");
      pstmt.setString(1, deptName);
      pstmt.setString(2, deptLoc);
      pstmt.setInt(3, deptNo) ;
      if (!(pstmt.executeUpdate() > 0)) {
        String error = "ejbStore: Deptartment (" + deptNo + ") not updated";
        System.out.println(error);
        throw new NoSuchEntityException (error);
      }
    } catch(SQLException e) {
      try {
      System.out.println("SQLException: " + e);
      throw new EJBException (e);
      } catch (EJBException ee) {System.out.println(ee);}
    } catch (NoSuchEntityException e) {System.out.println (e);}
      finally {
        try {
        if (pstmt != null) pstmt.close();
           } catch (SQLException e) {System.out.println (e);}
   }
  }


public Integer ejbCreate(Integer deptNo, String deptName, String deptLoc)
      throws CreateException, RemoteException 
  {
    this.deptNo = deptNo.intValue();
    this.deptName = deptName;
    this.deptLoc = deptLoc ;

    Connection conn = null;
    PreparedStatement pstmt = null;
    try {
      conn = getConnection();
      pstmt = conn.prepareStatement("insert into dept (deptNo, dname, loc) values (?, ?, ?)");
      pstmt.setInt(1, deptNo.intValue());
      System.out.println("ANS 1");
      pstmt.setString(2, deptName);
      pstmt.setString(3, deptLoc) ;
      int retval = pstmt.executeUpdate();
        if (retval != 1) {
        String error = "No Department row created";
        System.out.println(error);
        throw new CreateException (error);
      }
      else
      {
        System.out.println("Department created:");
      }
    } catch (SQLException e) {
            System.out.println("SQLException: " + e);
      try {
      System.out.println("SQLException: " + e);
      throw new EJBException (e);
      } catch (EJBException ee) {System.out.println(ee);}
    } finally {
         try {
        if (pstmt != null) pstmt.close();
         } catch (SQLException e) {System.out.println(e); }
    }
      return (deptNo);
  }


public void ejbPostCreate(Integer deptNo, String deptName, String deptLoc) {
    System.out.println("ejbPostCreate called");
  }

  public void ejbRemove() throws RemoteException {

    Connection conn = null;
    PreparedStatement pstmt = null;

    try {
      conn = getConnection();
      deptNo = (int) Integer.parseInt((String) ctx.getPrimaryKey());
      pstmt = conn.prepareStatement("delete from dept where deptNo = ?");
      pstmt.setInt(1, deptNo);
      if (!(pstmt.executeUpdate() > 0)) {
        String error = "DepartmentBean (" + deptNo + " not found";
        System.out.println(error);
        throw new NoSuchEntityException (error);
      }
    } catch (SQLException e) {
      try {
      System.out.println("SQLException:  " + e);
      throw new EJBException (e);
      } catch (EJBException ee) {System.out.println(ee);}
    } catch (NoSuchEntityException e) {System.out.println(e);}
      finally {
         try {
         if (pstmt != null) pstmt.close();
           } catch (SQLException e) {System.out.println(e);}
    }
  }

 public Integer ejbFindByPrimaryKey(Integer pk)
      throws FinderException, RemoteException
  {
    System.out.println("ejbFindByPrimaryKey (" + pk + ")");

    Connection conn = null;
    PreparedStatement pstmt = null;
    ResultSet rset = null;

    try {
      conn = getConnection();
      pstmt  = conn.prepareStatement("select dname, loc from dept where deptNo = ?");
      pstmt.setInt(1, pk.intValue());
      rset = pstmt.executeQuery();
      if (rset.next()) {
        deptName = rset.getString(1);
        deptLoc = rset.getString(2) ;
        System.out.println("ejbFindByPrimaryKey (" + pk + ") found");
      } else {
        String error = "ejbFindByPrimaryKey: Department (" + pk + ") not found";
        System.out.println(error);
          throw new FinderException(error);
       }
    } catch (SQLException e) {
       try {
      System.out.println("SQLException:  " + e);
      throw new EJBException (e);
        } catch (EJBException ee) {System.out.println(ee);}
    } catch (FinderException f) {System.out.println("Non-existent Dept:" + f);}
      finally {
        try {
        if (rset != null) rset.close();
        if (pstmt != null) pstmt.close();
       } catch (SQLException e) {System.out.println("SQLException:  " + e);}
    }

      return (pk);
  }

public void setDeptName(String deptName)
    throws RemoteException
{
	this.deptName = deptName ;
}

public void setDeptLocation(String deptLoc)
    throws RemoteException
 {
	 this.deptLoc = deptLoc ;
 }
  /**
    Return the name of the department
   */
  public String getDeptName()
    throws RemoteException
    {
		return deptName ;
    }
 /**
    Return the location of the department
   */
  public String getDeptLoc()
    throws RemoteException
    {
		return deptLoc ;
	}


private Connection getConnection()
    throws SQLException
  {
    try {
            Connection conn = new OracleDriver().defaultConnection();
            return conn;

     } catch (SQLException e) { System.out.println("Error getting Connection: " + e); return null;}
  }

}
